<?php
/*
Plugin Name: iDevAffiliate PMPro Integration
Plugin URI: http://www.idevdirect.com/
Description: Paid Memberships Pro / iDevAffiliate Integration
Version: 2.0
Author: iDevDirect.com LLC
Author URI: http://www.idevdirect.com/
*/

if(!defined('WPINC')) {
    die();
}

if(!class_exists('iDevAffiliate_PMPro')):
    class iDevAffiliate_PMPro {
        private static $instance;
        private $dir, $url, $table;
        const DS = '/';
        public static function getInstance() {
            global $wpdb;
            if(self::$instance==null) {
                self::$instance = new self;
                self::$instance->dir = dirname(__FILE__);
                self::$instance->url = plugins_url() . self::DS . basename(self::$instance->dir);
                self::$instance->table = "{$wpdb->prefix}idevaffiliate_pmpro";
                self::$instance->actions();
            }

            return self::$instance;
        }

        private function __construct() {
            ;
        }
        /**
         * call all actions/filters here
         */
        private function actions() {
            register_activation_hook(__FILE__, array($this,'activate'));
            register_deactivation_hook(__FILE__, array($this,'deactivate'));

            if( is_admin() ) {
                add_action( 'admin_init', array($this,'checkPMPro') );
                add_filter( 'pmpro_custom_advanced_settings', array($this,'adminSettings') );
            }

            //save ip address
            add_action( 'pmpro_checkout_before_change_membership_level', array($this, 'saveIP'), 1, 2);


            //call affiliate tracking code
            add_action( 'pmpro_updated_order', array($this,'trackingOrder'), 110, 1);
            add_action( 'pmpro_added_order', array($this, 'trackingOrder'), 100, 1);
        }

        public function activate() {
            global $wpdb;

            $key = 'idevaffiliate_pmpro_version2_updates';

            $processed = get_option( $key, '' );

            if ( $processed == 'done' )
                return;



            //get old order id and extract ip and user_id
            $query = "SELECT ip_tbl.order_id, ip_tbl.ip_address, ip_tbl.status, order_tbl.user_id  FROM `" . $this->table . "` as ip_tbl, `" . $wpdb->prefix . "pmpro_membership_orders` as order_tbl ";
            $query .= 'WHERE ip_tbl.order_id = order_tbl.id order by ip_tbl.id asc';

            $results = $wpdb->get_results($query, ARRAY_A);

            $user_ids = array();

            if ( !empty($results) ) {
                foreach ( $results as $row ) {

                    //check ip processed or not
                    if ( ! in_array( $row['user_id'], $user_ids ) ) {
                        //save ip address
                        update_user_meta( $row['user_id'], 'idevaffiliate_pmpro_user_ip', $row['ip_address'] );
                        $user_ids[] = $row['user_id'];
                    }

                    //check order processed or not
                    if ( $row['status'] == 1 ) {
                        $key2 = 'idevaffiliate_pmpro_order_processed_' . $row['order_id'];
                        update_option($key2, 'done', 'no');
                    }
                }

                //now drop table
                //$wpdb->query('DROP TABLE IF EXISTS `' . $this->table . '`');
                update_option($key, 'done');
            }
        }

        public function deactivate() {
            //
        }


        public function checkPMPro() {

            $plugin = plugin_basename( __FILE__ );
            if ( ! class_exists('MemberOrder') ) {
                ?>
                <div class="error"><p>
                        <?php printf(
                            __('<b>%s Integration</b>: Paid Membership Pro Plugin must be installed.', 'idevaffiliates'),
                            'iDevAffiliate PMPro'
                        ) ?>
                    </p></div>
                <?php

                deactivate_plugins( $plugin );
            }
        }

        public function adminSettings($custom_fields) {

            $custom_fields['pmpro_idevaffiliate_field2'] = array(
                'field_name' => 'custom_pmpro_idevaffiliate_url',
                'field_type' => 'text',
                'label' => 'iDevAffiliate Tracking URL',
                'description' => 'Example: http://www.yoursite.com/idevaffiliate/'
            );

            return $custom_fields;
        }

        public function saveIP( $user_id, $morder ) {
            //save ip address to usermeta
            $ip = getenv( 'HTTP_CLIENT_IP' ) ?: getenv( 'HTTP_X_FORWARDED_FOR' ) ?:
                getenv( 'HTTP_X_FORWARDED' ) ?: getenv( 'HTTP_FORWARDED_FOR' ) ?:
                    getenv( 'HTTP_FORWARDED' ) ?: getenv( 'REMOTE_ADDR' );
					
		//if (isset($_SERVER['HTTP_CF_CONNECTING_IP'])) {
		//$ip = $_SERVER['HTTP_CF_CONNECTING_IP'];
		//}

            update_user_meta( $user_id, 'idevaffiliate_pmpro_user_ip', $ip );
        }

        public function trackingOrder( $order ) {

            //wp_mail( 'jim@idevdirect.com', 'PMPro initial order data: mavoixtavoie.com server', 'Order Object: ' . print_r($order, true) );

            if($order->status !== 'success')
                return;

            global $wpdb;

            //check this order has been processed earlier
            $key2 = 'idevaffiliate_pmpro_order_processed_' . $order->id;

            $processed = get_option( $key2, '' );

            if ( $processed == 'done' )
                return;

            $alert_url = pmpro_getOption('custom_pmpro_idevaffiliate_url');
            $alert_url = rtrim($alert_url, '/');

            if( !$this->valid_url( $alert_url ) ) {
                //wp_mail( get_option( 'admin_email' ), 'iDevAffiliate PMPro Integration', 'Invalid Alert URL (' . $alert_url . ') <br>Order Data: ' . print_r($order, true) );
                return;
            }

            //get user id
            if( !is_numeric($order->user_id) ) {
                //wp_mail( get_option( 'admin_email' ), 'iDevAffiliate PMPro Integration', 'Invalid User ID <br>Order Data: ' . print_r($order, true) );
                return;
            }
			
			$data['profile'] = '115';

            //get ip address
            $ip_address = get_user_meta( $order->user_id, 'idevaffiliate_pmpro_user_ip', true );
			$data['ip_address'] = strstr($ip_address, ',', true);
            if( $ip_address == '' ) {
                //wp_mail( get_option( 'admin_email' ), 'iDevAffiliate PMPro Integration', 'Invalid IP Address <br>Order Data: ' . print_r($order, true) );
                return;
            }


            // Order Details
            $data['idev_ordernum'] = $order->id;
            $data['idev_saleamt'] = $order->subtotal;

            if ( $data['idev_saleamt'] <= 0 ) {
                return;
            }

            //get Coupon Code
            //$coupon = $order->getDiscountCode();

            //Get Coupon Code
            $data['coupon_code'] = '';
            if(isset($order->discount_code) && is_object($order->discount_code)) {
                $data['coupon_code'] = $order->discount_code->code;
            }
            elseif(isset ($order->discount_code) && !is_object($order->discount_code) && $order->discount_code != '') {
                $data['coupon_code'] = $order->discount_code;
            }
            else {
                $query = $wpdb->prepare("SELECT dc.* FROM $wpdb->pmpro_discount_codes dc LEFT JOIN $wpdb->pmpro_discount_codes_uses dcu ON dc.id = dcu.code_id WHERE dcu.order_id = %s LIMIT 1", array($order_id));
                $coupon_data = $wpdb->get_row($query,ARRAY_A);
                if(is_array($coupon_data) && isset($coupon_data['code']))
                    $data['coupon_code'] = $coupon_data['code'];
            }

            //$url = "{$alert_url}/sale.php?profile=115&idev_saleamt={$total}&idev_ordernum={$order_id}&coupon_code={$coupon}&ip_address={$ip_address}";
			
			$url = "{$alert_url}/sale.php";
			
			/*
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CAINFO, $this->dir . "/cacert/cacert.pem");
            $content = curl_exec( $ch );
            $err     = curl_errno( $ch );
            $errmsg  = curl_error( $ch );
            $header  = curl_getinfo( $ch );
            curl_close($ch);
			*/
			
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    $json = curl_exec($ch);
    curl_close($ch);
	
	//wp_mail('jim@idevdirect.com', 'PMPRO Webhook Passed Data', print_r($data, true));

            update_option($key2, 'done', 'no');

            //wp_mail('zikubd@gmail.com', 'PMPro Test: https://www.idevtest.com/wordpress/ server', 'idev call success. url: ' . $url);
            //wp_mail('jim@idevdirect.com', 'PMPro Test: https://www.idevtest.com/wordpress/ server', 'idev call success. url: ' . $url);
        }

        public function valid_url( $url ) {
            $regex = "((https?|ftp)\:\/\/)?"; // SCHEME
            $regex .= "([a-z0-9+!*(),;?&=\$_.-]+(\:[a-z0-9+!*(),;?&=\$_.-]+)?@)?"; // User and Pass
            $regex .= "([a-z0-9-.]*)\.([a-z]{2,3})"; // Host or IP
            $regex .= "(\:[0-9]{2,5})?"; // Port
            $regex .= "(\/([a-z0-9+\$_-]\.?)+)*\/?"; // Path
            $regex .= "(\?[a-z+&\$_.-][a-z0-9;:@&%=+\/\$_.-]*)?"; // GET Query
            $regex .= "(#[a-z_.-][a-z0-9+\$_.-]*)?"; // Anchor

            if (preg_match("/^$regex$/", $url)) {
                return true;
            } else {
                return false;
            }
        }
    }

    iDevAffiliate_PMPro::getInstance();
endif;